'37_in_1, KY-001, Temperature Sensor Module (DS18B20)
'37_in_1, KY-013, Analog Temperature Sensor Module
'R0 & beta measurement

$regfile = "m328pdef.dat"
$crystal = 16000000
$hwstack = 20
$swstack = 20
$framesize = 80

Dim Cmd As Byte
Dim Temp_1 As Single , Temp_2 As Single
Dim Rt_1 As Single , Rt_2 As Single
Dim Adc_value As Word , Beta As Single

'Config Base = 1
Config Clockdiv = 1

$include "Arduino_pins.sub"                                 'include Arduino pin definitions
$include "DS18B20$SE.sub"                                   'include DS18B20$SE.sub

Config Arduino_pin#2 = Input
Arduino_port#2 = 1

Config 1wire = Arduino_port#7
Config Adc = Single , Prescaler = Auto , Reference = Avcc

Wait 1
Print "37_in_1 demo program 12"
Print "#2 = digital input"
Print "#7 = 1-wire"
Print "#A0 = analog input"
Print

Do
  Gosub Measure_temp
  Debounce Arduino_pin#2 , 0 , Measure , Sub
  Cmd = Inkey()
  If Cmd = "1" Then
    Gosub Measure
  End If
Loop

End

Measure:
  Gosub Measure_temp
  Temp_1 = Temp_1 + 273.15
  Temp_1 = 1 / Temp_1
  Print
  Gosub Measure_ntc
  If Rt_2 <> 0 And Temp_2 <> 0 Then
    Gosub Calc_beta
  End If
  Rt_2 = Rt_1
  Temp_2 = Temp_1
Return

Measure_temp:
  Print Chr(13) ; "t = ";
  Ds18b20$measure_temp
  If Err = 0 Then
    Waitms 800
    Ds18b20$read_temp
  End If
  If Err = 0 Then
    Temp_1 = Ds18b20$temp / 16
    Print Fusing(temp_1 , "#.#") ; "C   " ;
  Else
    Print "DS18B20?    "
  End If
Return

Measure_ntc:
  Adc_value = Getadc(0)
  Print "ADC = " ; Adc_value
  Rt_1 = 1023 / Adc_value
  Rt_1 = Rt_1 - 1
  Rt_1 = 1 / Rt_1
  Print "Rt/R1 = " ; Fusing(rt_1 , "#.####")
Return

Calc_beta:
  Beta = Rt_1 / Rt_2
  Beta = Log(beta)
  Temp_2 = Temp_1 - Temp_2
  Beta = Beta / Temp_2
  Print "beta = " ; Fusing(beta , "#.#")
Return
