'37_in_1, KY-001, Temperature Sensor Module (DS18B20)
'37_in_1, KY-013, Analog Temperature Sensor Module

$regfile = "m328pdef.dat"
$crystal = 16000000
$hwstack = 20
$swstack = 20
$framesize = 80

Dim Cmd As Byte
Dim Adc_value As Word , Rt As Single , Temp As Single

Const Beta = 3884.1
Const R0r1 = 1.0501                                         'R0/R1

Config Clockdiv = 1

$include "Arduino_pins.sub"                                 'include Arduino pin definitions
$include "DS18B20$SE.sub"                                   'include DS18B20$SE.sub

Config Arduino_pin#2 = Input
Arduino_port#2 = 1

Config 1wire = Arduino_port#7
Config Adc = Single , Prescaler = Auto , Reference = Avcc

Wait 1
Print "37_in_1 demo program 13"
Print "#2 = digital input"
Print "#7 = 1-wire"
Print "#A0 = analog input"
Print

Do
  Gosub Measure_temp
  Debounce Arduino_pin#2 , 0 , Measure , Sub
  Cmd = Inkey()
  If Cmd = "1" Then
    Gosub Measure
  End If
Loop

End

Measure:
  Gosub Measure_ntc
  Gosub Calc_ntc_temp
  Print
Return

Measure_ntc:
  Adc_value = Getadc(0)
  Rt = 1023 / Adc_value
  Rt = Rt - 1
  Rt = 1 / Rt
Return

Calc_ntc_temp:
  Temp = Rt / R0r1
  Temp = Log(temp)
  Temp = Temp / Beta
  Temp = Temp + 3.354e-3                                    '1/(273.15+25)
  Temp = 1 / Temp
  Temp = Temp - 273.15
  Print "t = " ; Fusing(temp , "#.#") ; "C KY-013(NTC)"
Return

Measure_temp:
  Print Chr(13) ; "t = ";
  Ds18b20$measure_temp
  If Err = 0 Then
    Waitms 800
    Ds18b20$read_temp
  End If
  If Err = 0 Then
    Temp = Ds18b20$temp / 16
    Print Fusing(temp , "#.#") ; "C KY-001(DS18B20)  ";
  Else
    Print "DS18B20?  ";
  End If
Return